#include "APM10.h"
#include "iic.h"

extern	u16 PM1_0;
extern	u16 PM2_5;
extern	u16 PM4_0;
extern	u16 PM10;


u8 APM10_Start(ComTypeDef IIC_COM)
{
	
	IIC_Start(IIC_COM);
	IIC_WR_Byte(0x10,IIC_COM);
	if(Receive_ACK(IIC_COM)==1)return 1;
	IIC_WR_Byte(0x00,IIC_COM);
	if(Receive_ACK(IIC_COM)==1)return 1;
	IIC_WR_Byte(0x10,IIC_COM);
	if(Receive_ACK(IIC_COM)==1)return 1;
	IIC_WR_Byte(0x05,IIC_COM);
	if(Receive_ACK(IIC_COM)==1)return 1;
	IIC_WR_Byte(0x00,IIC_COM);
	if(Receive_ACK(IIC_COM)==1)return 1;
	IIC_WR_Byte(0xf6,IIC_COM);
	if(Receive_ACK(IIC_COM)==1)return 1;
	IIC_Stop(IIC_COM);
}







u16 APM10_Read_PM2_5(ComTypeDef IIC_COM)
{
	u8 Byte[2],CRC_Byte;

	Init_IIC_Sensor_Port(IIC_COM);
	
	APM10_Start(IIC_COM);

	IIC_Start(IIC_COM);
	IIC_WR_Byte(0x10,IIC_COM);
	if(Receive_ACK(IIC_COM)==1)return 1;
	IIC_WR_Byte(0x03,IIC_COM);
	if(Receive_ACK(IIC_COM)==1)return 1;
	IIC_WR_Byte(0x00,IIC_COM);
	if(Receive_ACK(IIC_COM)==1)return 1;
	IIC_Stop(IIC_COM);
	
	IIC_Start(IIC_COM);
	IIC_WR_Byte(0x11,IIC_COM);
	if(Receive_ACK(IIC_COM)==1)return 1;
	IIC_RD_Byte(IIC_COM);
	Send_ACK(IIC_COM);
	IIC_RD_Byte(IIC_COM);
	Send_ACK(IIC_COM);
	IIC_RD_Byte(IIC_COM);
	Send_ACK(IIC_COM);
	Byte[0]=IIC_RD_Byte(IIC_COM);
	Send_ACK(IIC_COM);
	Byte[1]=IIC_RD_Byte(IIC_COM);
	Send_ACK(IIC_COM);
	CRC_Byte=IIC_RD_Byte(IIC_COM);
	Send_NOT_ACK(IIC_COM);
	IIC_Stop(IIC_COM);
	
	if(Calc_CRC8(Byte,2)!=CRC_Byte)return 2;
	
	PM2_5=(PM2_5|Byte[0])<<8;
	PM2_5=PM2_5|Byte[1];
	
	
	
	return 0;
	
	
	
}



u16 APM10_Read_ALL_Data(ComTypeDef IIC_COM)
{
	u8 i;
	u8 Byte[12]={0};

	Init_IIC_Sensor_Port(IIC_COM);
	
	APM10_Start(IIC_COM);

	IIC_Start(IIC_COM);
	IIC_WR_Byte(0x10,IIC_COM);
	if(Receive_ACK(IIC_COM)==1)return 1;
	IIC_WR_Byte(0x03,IIC_COM);
	if(Receive_ACK(IIC_COM)==1)return 1;
	IIC_WR_Byte(0x00,IIC_COM);
	if(Receive_ACK(IIC_COM)==1)return 1;
	IIC_Stop(IIC_COM);
	
	
	IIC_Start(IIC_COM);
	IIC_WR_Byte(0x11,IIC_COM);
	if(Receive_ACK(IIC_COM)==1)return 1;

	for(i=0;i<12;i++)
	{
		Byte[i]=IIC_RD_Byte(IIC_COM);
		
		if(i==11)
		{
			Send_NOT_ACK(IIC_COM);
		}else
			{
		Send_ACK(IIC_COM);
			}
				
	}
	IIC_Stop(IIC_COM);

	
	PM1_0=((u16)Byte[0]<<8)+Byte[1];
	if(Calc_CRC8(Byte,2)!=Byte[2])return 2;
	
	PM2_5=((u16)Byte[3]<<8)+Byte[4];
	if(Calc_CRC8(Byte+3,2)!=Byte[5])return 2;
	
	PM4_0=((u16)Byte[6]<<8)+Byte[7];
	if(Calc_CRC8(Byte+6,2)!=Byte[8])return 2;
	
	PM10=((u16)Byte[9]<<8)+Byte[10];
	if(Calc_CRC8(Byte+9,2)!=Byte[11])return 2;
	
//	for(i=0;i<4;i++)
//	{
//		if(Calc_CRC8(Byte+i*3,2)!=Byte[i*3+2])return 2;
//	}
//	
//	PM1_0=Byte[0]*256+Byte[1];
//	
//	PM2_5=Byte[3]*256+Byte[4];
//	
//	PM4_0=Byte[6]*256+Byte[7];
//	
//	PM10=Byte[9]*256+Byte[10];
	
	
	
	
	return 0;
	
	
	
}








